
package org.greenstone.gsdl3.core;

import java.io.IOException;

import jakarta.servlet.Filter;
import jakarta.servlet.FilterChain;
import jakarta.servlet.FilterConfig;
import jakarta.servlet.ServletException;
import jakarta.servlet.ServletRequest;
import jakarta.servlet.ServletResponse;

import org.greenstone.gsdl3.util.XMLConverter;

public class ThreadLocalCleanUpFilter implements Filter {

    @Override
    public void init(FilterConfig filterConfig) throws ServletException {
        // nothing to initialise
    }

    @Override
    public void doFilter(ServletRequest request,
                         ServletResponse response,
                         FilterChain chain)
            throws IOException, ServletException {

        try {
            // Continue request processing
            chain.doFilter(request, response);
        } finally {
            // VERY IMPORTANT: clean up ThreadLocals to avoid memory leaks
            XMLConverter.clearThreadLocalParser();
        }
    }

    @Override
    public void destroy() {
        // nothing to destroy
    }
}

